"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.useCollector = useCollector;
var _fastDeepEqual = _interopRequireDefault(require("fast-deep-equal"));
var _vue = require("vue");
function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
        default: obj
    };
}
function useCollector(monitor, collect, onUpdate) {
    var collected = (0, _vue).ref((0, _vue).unref(collect)((0, _vue).unref(monitor)));
    var updateCollected = function() {
        var nextValue = (0, _vue).unref(collect)((0, _vue).unref(monitor));
        // This needs to be a deep-equality check because some monitor-collected values
        // include XYCoord objects that may be equivalent, but do not have instance equality.
        if (!(0, _fastDeepEqual).default(collected, nextValue)) {
            collected.value = nextValue;
            if (onUpdate) {
                onUpdate();
            }
        }
    };
    // update the collected properties after react renders.
    // Note that the "Dustbin Stress Test" fails if this is not
    // done when the component updates
    (0, _vue).watchEffect(updateCollected);
    return [
        collected,
        updateCollected
    ];
}
